"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.buildDevStandalone = buildDevStandalone;
exports.buildDev = buildDev;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _express = _interopRequireDefault(require("express"));

var _https = _interopRequireDefault(require("https"));

var _ip = _interopRequireDefault(require("ip"));

var _serveFavicon = _interopRequireDefault(require("serve-favicon"));

var _path = _interopRequireDefault(require("path"));

var _fs = _interopRequireDefault(require("fs"));

var _chalk = _interopRequireDefault(require("chalk"));

var _nodeLogger = require("@storybook/node-logger");

var _nodeFetch = _interopRequireDefault(require("node-fetch"));

var _fileSystemCache = _interopRequireDefault(require("file-system-cache"));

var _opn = _interopRequireDefault(require("opn"));

var _boxen = _interopRequireDefault(require("boxen"));

var _semver = _interopRequireDefault(require("semver"));

var _commonTags = require("common-tags");

var _ttyTable = _interopRequireDefault(require("tty-table"));

var _middleware = _interopRequireWildcard(require("./middleware"));

var _cli = require("./cli");

require("./config/env");

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n          Could not open ", " inside a browser. If you're running this command inside a\n          docker container or on a CI, you need to pass the '--ci' flag to prevent opening a\n          browser by default.\n        "]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n          ", "\n\n          ", "", "\n        "]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n          ", "\n          ", "\n\n          ", "\n          ", "\n        "]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var defaultFavIcon = require.resolve('./public/favicon.ico');

var cache = (0, _fileSystemCache.default)({
  ns: 'storybook' // Optional. A grouping namespace for items.

});

function getServer(app, options) {
  if (!options.https) {
    return app;
  }

  if (!options.sslCert) {
    _nodeLogger.logger.error('Error: --ssl-cert is required with --https');

    process.exit(-1);
  }

  if (!options.sslKey) {
    _nodeLogger.logger.error('Error: --ssl-key is required with --https');

    process.exit(-1);
  }

  var sslOptions = {
    ca: (options.sslCa || []).map(function (ca) {
      return _fs.default.readFileSync(ca, 'utf-8');
    }),
    cert: _fs.default.readFileSync(options.sslCert, 'utf-8'),
    key: _fs.default.readFileSync(options.sslKey, 'utf-8')
  };
  return _https.default.createServer(sslOptions, app);
}

function applyStatic(app, options) {
  var staticDir = options.staticDir;
  var hasCustomFavicon = false;

  if (staticDir) {
    staticDir.forEach(function (dir) {
      var staticPath = _path.default.resolve(dir);

      if (!_fs.default.existsSync(staticPath)) {
        _nodeLogger.logger.error("Error: no such directory to load static files: ".concat(staticPath));

        process.exit(-1);
      }

      _nodeLogger.logger.info("=> Loading static files from: ".concat(staticPath, " ."));

      app.use(_express.default.static(staticPath, {
        index: false
      }));

      var faviconPath = _path.default.resolve(staticPath, 'favicon.ico');

      if (_fs.default.existsSync(faviconPath)) {
        hasCustomFavicon = true;
        app.use((0, _serveFavicon.default)(faviconPath));
      }
    });
  }

  if (!hasCustomFavicon) {
    app.use((0, _serveFavicon.default)(defaultFavIcon));
  }
}

var updateCheck =
/*#__PURE__*/
function () {
  var _ref = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee() {
    var result, time, fromCache, fromFetch, data;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            time = Date.now();
            _context.prev = 1;
            _context.next = 4;
            return cache.get('lastUpdateCheck', {
              success: false,
              time: 0
            });

          case 4:
            fromCache = _context.sent;

            if (!(time - 86400000 > fromCache.time)) {
              _context.next = 17;
              break;
            }

            _context.next = 8;
            return (0, _nodeFetch.default)('https://storybooks.netlify.com/versions.json');

          case 8:
            fromFetch = _context.sent;
            _context.next = 11;
            return fromFetch.json();

          case 11:
            data = _context.sent;
            result = {
              success: true,
              data: data,
              time: time
            };
            _context.next = 15;
            return cache.set('lastUpdateCheck', result);

          case 15:
            _context.next = 18;
            break;

          case 17:
            result = fromCache;

          case 18:
            _context.next = 23;
            break;

          case 20:
            _context.prev = 20;
            _context.t0 = _context["catch"](1);
            result = {
              success: false,
              error: _context.t0,
              time: time
            };

          case 23:
            return _context.abrupt("return", result);

          case 24:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this, [[1, 20]]);
  }));

  return function updateCheck() {
    return _ref.apply(this, arguments);
  };
}();

function listenToServer(server, listenAddr) {
  var serverResolve = function serverResolve() {};

  var serverReject = function serverReject() {};

  var serverListening = new Promise(function (resolve, reject) {
    serverResolve = resolve;
    serverReject = reject;
  });
  server.listen.apply(server, (0, _toConsumableArray2.default)(listenAddr).concat([function (error) {
    if (error) {
      serverReject(error);
    } else {
      serverResolve();
    }
  }]));
  return serverListening;
}

function buildDevStandalone(_x) {
  return _buildDevStandalone.apply(this, arguments);
}

function _buildDevStandalone() {
  _buildDevStandalone = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee2(options) {
    var port, host, listenAddr, app, server, serverListening, _ref3, _ref4, stats, updateInfo, proto, address, networkAddress, updateMessage, serveMessage;

    return _regenerator.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.prev = 0;
            port = options.port, host = options.host; // Used with `app.listen` below

            listenAddr = [port];

            if (host) {
              listenAddr.push(host);
            }

            app = (0, _express.default)();
            server = getServer(app, options);
            applyStatic(app, options);
            app.use((0, _middleware.default)(options));
            serverListening = listenToServer(server, listenAddr);
            _context2.next = 11;
            return Promise.all([_middleware.webpackValid, updateCheck(), serverListening]);

          case 11:
            _ref3 = _context2.sent;
            _ref4 = (0, _slicedToArray2.default)(_ref3, 2);
            stats = _ref4[0];
            updateInfo = _ref4[1];
            proto = options.https ? 'https' : 'http';
            address = "".concat(proto, "://").concat(options.host || 'localhost', ":").concat(port, "/");
            networkAddress = "".concat(proto, "://").concat(_ip.default.address(), ":").concat(port, "/");

            try {
              updateMessage = updateInfo.success && _semver.default.lt(options.packageJson.version, updateInfo.data.latest.version) ? (0, _commonTags.stripIndents)(_templateObject(), _chalk.default.hex('#F3AD38')("A new version (".concat(_chalk.default.bold(updateInfo.data.latest.version), ") is available!")), _chalk.default.gray(updateInfo.data.latest.info.plain), _chalk.default.gray('Read full changelog here:'), _chalk.default.gray.underline('https://git.io/fxc61')) : '';
            } catch (e) {
              updateMessage = '';
            }

            serveMessage = (0, _commonTags.stripIndents)((0, _ttyTable.default)([['Local', _chalk.default.cyan(address)], ['On your network', _chalk.default.cyan(networkAddress)]], {
              borderStyle: 0,
              paddingLeft: 0,
              compact: true,
              paddingBottom: 0,
              align: 'left',
              color: 'white'
            }).render()); // eslint-disable-next-line no-console

            console.log((0, _boxen.default)((0, _commonTags.stripIndents)(_templateObject2(), _chalk.default.hex('#A2E05E')("Storybook ".concat(_chalk.default.bold(options.packageJson.version), " started")), serveMessage, updateMessage ? "\n\n".concat(updateMessage) : ''), {
              borderStyle: 'round',
              padding: 1,
              borderColor: '#F1618C'
            }));

            if (options.smokeTest) {
              process.exit(stats.toJson().warnings.length ? 1 : 0);
            } else if (!options.ci) {
              (0, _opn.default)(address).catch(function () {
                _nodeLogger.logger.error((0, _commonTags.stripIndents)(_templateObject3(), address));
              });
            }

            _context2.next = 28;
            break;

          case 24:
            _context2.prev = 24;
            _context2.t0 = _context2["catch"](0);

            if (_context2.t0 instanceof Error) {
              _nodeLogger.logger.error(_context2.t0);
            }

            if (options.smokeTest) {
              process.exit(1);
            }

          case 28:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this, [[0, 24]]);
  }));
  return _buildDevStandalone.apply(this, arguments);
}

function buildDev(_x2) {
  return _buildDev.apply(this, arguments);
}

function _buildDev() {
  _buildDev = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee3(_ref2) {
    var packageJson, loadOptions, cliOptions;
    return _regenerator.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            packageJson = _ref2.packageJson, loadOptions = (0, _objectWithoutProperties2.default)(_ref2, ["packageJson"]);
            _context3.next = 3;
            return (0, _cli.getDevCli)(packageJson);

          case 3:
            cliOptions = _context3.sent;
            _context3.next = 6;
            return buildDevStandalone((0, _objectSpread2.default)({}, cliOptions, loadOptions, {
              packageJson: packageJson,
              configDir: cliOptions.configDir || './.storybook'
            }));

          case 6:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));
  return _buildDev.apply(this, arguments);
}