"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _commander = _interopRequireDefault(require("commander"));

var _chalk = _interopRequireDefault(require("chalk"));

var _detectPort = _interopRequireDefault(require("detect-port"));

var _inquirer = _interopRequireDefault(require("inquirer"));

var _nodeLogger = require("@storybook/node-logger");

var _utils = require("./utils");

var getFreePort = function getFreePort(port) {
  return (0, _detectPort.default)(port).catch(function (error) {
    _nodeLogger.logger.error(error);

    process.exit(-1);
  });
};

function getCLI(_x) {
  return _getCLI.apply(this, arguments);
}

function _getCLI() {
  _getCLI = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(packageJson) {
    var port, _ref, shouldChangePort;

    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            process.env.NODE_ENV = process.env.NODE_ENV || 'development';

            _commander.default.version(packageJson.version).option('-p, --port [number]', 'Port to run Storybook', function (str) {
              return parseInt(str, 10);
            }).option('-h, --host [string]', 'Host to run Storybook').option('-s, --static-dir <dir-names>', 'Directory where to load static files from', _utils.parseList).option('-c, --config-dir [dir-name]', 'Directory where to load Storybook configurations from').option('--https', 'Serve Storybook over HTTPS. Note: You must provide your own certificate information.').option('--ssl-ca <ca>', 'Provide an SSL certificate authority. (Optional with --https, required if using a self-signed certificate)', _utils.parseList).option('--ssl-cert <cert>', 'Provide an SSL certificate. (Required with --https)').option('--ssl-key <key>', 'Provide an SSL key. (Required with --https)').option('--smoke-test', 'Exit after successful start').option('--ci', "CI mode (skip interactive prompts, don't open browser").option('--quiet', 'Suppress verbose build output').parse(process.argv);

            _nodeLogger.logger.info(_chalk.default.bold("".concat(packageJson.name, " v").concat(packageJson.version)) + _chalk.default.reset('\n')); // The key is the field created in `program` variable for
            // each command line argument. Value is the env variable.


            (0, _utils.getEnvConfig)(_commander.default, {
              port: 'SBCONFIG_PORT',
              host: 'SBCONFIG_HOSTNAME',
              staticDir: 'SBCONFIG_STATIC_DIR',
              configDir: 'SBCONFIG_CONFIG_DIR'
            });
            _context.next = 6;
            return getFreePort(_commander.default.port);

          case 6:
            port = _context.sent;

            if (!(!_commander.default.ci && !_commander.default.smokeTest && _commander.default.port != null && port !== _commander.default.port)) {
              _context.next = 13;
              break;
            }

            _context.next = 10;
            return _inquirer.default.prompt({
              type: 'confirm',
              default: true,
              name: 'shouldChangePort',
              message: "Port ".concat(_commander.default.port, " is not available.\nWould you like to run Storybook on port ").concat(port, " instead?")
            });

          case 10:
            _ref = _context.sent;
            shouldChangePort = _ref.shouldChangePort;

            if (!shouldChangePort) {
              process.exit(1);
            }

          case 13:
            return _context.abrupt("return", (0, _objectSpread2.default)({}, _commander.default, {
              port: port
            }));

          case 14:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));
  return _getCLI.apply(this, arguments);
}

var _default = getCLI;
exports.default = _default;