"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createPreviewEntry = createPreviewEntry;
exports.createManagerEntry = createManagerEntry;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

function createPreviewEntry(options) {
  var configDir = options.configDir,
      presets = options.presets;
  var preview = [require.resolve('./polyfills'), require.resolve('./globals')];
  var configs = presets.apply('config', [], options);

  if (!configs || !configs.length) {
    throw new Error("=> Create a storybook config file in \"".concat(configDir, "/config.{ext}\"."));
  }

  preview.push.apply(preview, (0, _toConsumableArray2.default)(configs));
  return preview;
}

function createManagerEntry(options) {
  var presets = options.presets;
  var manager = [require.resolve('./polyfills')];
  var addons = presets.apply('addons', [], options);

  if (addons && addons.length) {
    manager.push.apply(manager, (0, _toConsumableArray2.default)(addons));
  }

  manager.push(require.resolve('../../client/manager'));
  return manager;
}