"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.webpack = webpack;
exports.babel = babel;
exports.manager = manager;
exports.preview = preview;
exports.addons = addons;
exports.config = config;

var _loadCustomBabelConfig = _interopRequireDefault(require("./loadCustomBabelConfig"));

var _loadCustomAddonsFile = _interopRequireDefault(require("./loadCustomAddonsFile"));

var _loadCustomConfigFile = _interopRequireDefault(require("./loadCustomConfigFile"));

var _webpackConfig = _interopRequireDefault(require("./config/webpack.config.prod"));

var _babel = _interopRequireDefault(require("./config/babel.prod"));

var _entries = require("./config/entries");

function webpack(_, options) {
  return (0, _webpackConfig.default)(options);
}

function babel(_, options) {
  var configDir = options.configDir,
      presets = options.presets;
  return (0, _loadCustomBabelConfig.default)(configDir, function () {
    return presets.apply('babelDefault', _babel.default, options);
  });
}

function manager(_, options) {
  return (0, _entries.createManagerEntry)(options);
}

function preview(_, options) {
  return (0, _entries.createPreviewEntry)(options);
}

function addons(_, options) {
  return (0, _loadCustomAddonsFile.default)(options);
}

function config(_, options) {
  return (0, _loadCustomConfigFile.default)(options);
}