"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getInterpretedFile = getInterpretedFile;
exports.getInterpretedFileWithExt = getInterpretedFileWithExt;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _fs = _interopRequireDefault(require("fs"));

var _interpret = require("interpret");

var boost = new Set(['.js', '.jsx', '.ts', '.tsx']);

function sortExtensions() {
  return (0, _toConsumableArray2.default)(Array.from(boost)).concat((0, _toConsumableArray2.default)(Object.keys(_interpret.extensions).filter(function (ext) {
    return !boost.has(ext);
  }).sort(function (a, b) {
    return a.length - b.length;
  })));
}

var possibleExtensions = sortExtensions();

function getInterpretedFile(pathToFile) {
  return possibleExtensions.map(function (ext) {
    return "".concat(pathToFile).concat(ext);
  }).find(function (candidate) {
    return _fs.default.existsSync(candidate);
  });
}

function getInterpretedFileWithExt(pathToFile) {
  return possibleExtensions.map(function (ext) {
    return {
      path: "".concat(pathToFile).concat(ext),
      ext: ext
    };
  }).find(function (candidate) {
    return _fs.default.existsSync(candidate.path);
  });
}