"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _mockFs = _interopRequireDefault(require("mock-fs"));

var _interpretFiles = require("./interpret-files");

describe('interpret-files', function () {
  it('will interpret file as file.ts when it exists in fs', function () {
    (0, _mockFs.default)({
      'path/to/file.ts': 'ts file contents'
    });
    var file = (0, _interpretFiles.getInterpretedFile)('path/to/file');
    expect(file).toEqual('path/to/file.ts');
  });
  it('will interpret file as file.js when both are in fs', function () {
    (0, _mockFs.default)({
      'path/to/file.js': 'js file contents',
      'path/to/file.ts': 'ts file contents'
    });
    var file = (0, _interpretFiles.getInterpretedFile)('path/to/file');
    expect(file).toEqual('path/to/file.js');
  });
  it('will return undefined if there is no candidate of a file in fs', function () {
    (0, _mockFs.default)({
      'path/to/file.js': 'js file contents'
    });
    var file = (0, _interpretFiles.getInterpretedFile)('path/to/file2');
    expect(file).toBeUndefined();
  });
  afterEach(_mockFs.default.restore);
});